// iZRs

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Red
#property  indicator_color2  Blue
#property  indicator_color3  ForestGreen

#property indicator_maximum 100
#property indicator_minimum 0
#property indicator_level1 20
#property indicator_level2 50
#property indicator_level3 80
//---- indicator parameters
extern int ma=5;
extern int s1=5;
extern int s2=1;

//---- indicator buffers
double   MA[], RSI[], STO[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(0,RSI);
   SetIndexDrawBegin(0,0);
   
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(1,MA);
   SetIndexDrawBegin(1,0);

   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(2,STO);
   SetIndexDrawBegin(2,0);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("iZRs");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   for(int i=0; i<limit; i++){
      RSI[i]=iRSI(NULL,0,3,6,i);
   }
   
   for(i=0; i<limit; i++){
      MA[i]=iMAOnArray(RSI,Bars,ma,0,0,i);
   }

   for(i=0; i<limit; i++){
      STO[i]=iStochastic(NULL,0,s1,1,s2,3,0,MODE_MAIN,i);
   }
   
   return(0);
  }
//+------------------------------------------------------------------+